Index: /server/trunk/web/lib/Sophie/Controller/Chat.pm
===================================================================
--- /server/trunk/web/lib/Sophie/Controller/Chat.pm	(revision 188)
+++ /server/trunk/web/lib/Sophie/Controller/Chat.pm	(revision 189)
@@ -27,4 +27,15 @@
     my ( $self, $c ) = @_;
 
+    $c->stash->{template} = 'chat/index.html';
+    if (my $cmd = $c->req->param('cmd')) {
+        $c->forward('message', [
+            [{
+                distribution => $c->req->param('distribution') || undef,
+                release => $c->req->param('release') || undef,
+                arch => $c->req->param('arch') || undef,
+                max_line => 30,
+                no_paste => 1,
+            }], $cmd ]);
+    }
 
 }
@@ -45,16 +56,17 @@
     my @contexts = grep { $_ } (
         $c->user_exists
-        ? ( 'default',
-            (ref $contexts
-                ? (@$contexts)
-                : ($contexts)
-            ),
-        )
-        : ()
+        ? ( 'default' )
+        : (),
+        (ref $contexts
+            ? (@$contexts)
+            : ($contexts)
+        ),
     );
 
     foreach my $co (@contexts) {
+        warn $co;
         if (ref($co) eq 'HASH') {
             foreach (keys %$co) {
+                warn $_;
                 $reqspec->{$_} = $co->{$_};
             }
Index: /server/trunk/web/lib/Sophie/Controller/Chat/Cmd.pm
===================================================================
--- /server/trunk/web/lib/Sophie/Controller/Chat/Cmd.pm	(revision 188)
+++ /server/trunk/web/lib/Sophie/Controller/Chat/Cmd.pm	(revision 189)
@@ -43,5 +43,5 @@
     } 
 
-    if ($needpaste) {
+    if ($needpaste && !$reqspec->{nopaste}) {
         my $id = $c->forward('/chat/paste', [ 'Bot paste', join("\n", @backup) ]);
         if ($id) {
Index: /server/trunk/web/root/static/sophie.css
===================================================================
--- /server/trunk/web/root/static/sophie.css	(revision 188)
+++ /server/trunk/web/root/static/sophie.css	(revision 189)
@@ -197,4 +197,9 @@
 }
 
+div#sophie_bot_reply {
+    padding: 1em;
+    border: solid;
+}
+
 .sophie_help h2 {
     font-size: 1.2em;
Index: /server/trunk/web/root/templates/html/chat/index.html
===================================================================
--- /server/trunk/web/root/templates/html/chat/index.html	(revision 188)
+++ /server/trunk/web/root/templates/html/chat/index.html	(revision 189)
@@ -1,1 +1,26 @@
 <!-- $Id$ -->
+
+<div style="float: left; width: 35%">
+    <form id="botform" action="[% c.uri_for('/chat') %]">
+            <div id="distribselect">
+            [% INCLUDE 'ajax/forms/distribselect.tt' %]
+            </div>
+            [% c.prototype.observe_form('botform',
+            {
+            url => c.uri_for('/ajax/forms/distribselect', {
+            'ajax' => 1 }),
+            frequency => 2,
+            update => 'distribselect',
+            }
+            ) %]
+        <input name="cmd" value="[% c.req.param('cmd') | html %]">
+        <input type="submit">
+    </form>
+</div>
+<div id="sophie_bot_help" style="float: left; width: 50%">
+    <p>This page simulate the Bot behavior you may meet on IRC.</p>
+</div>
+
+<div id="sophie_bot_reply" style="clear: both">
+    [% INCLUDE 'chat/index.tt' %]
+</div>
Index: /server/trunk/web/root/templates/html/chat/index.tt
===================================================================
--- /server/trunk/web/root/templates/html/chat/index.tt	(revision 189)
+++ /server/trunk/web/root/templates/html/chat/index.tt	(revision 189)
@@ -0,0 +1,4 @@
+<!-- $Id$ -->
+<pre>
+[% xmlrpc.message.join("\n") %]
+</pre>
Index: /server/trunk/web/root/templates/includes/header.tt
===================================================================
--- /server/trunk/web/root/templates/includes/header.tt	(revision 188)
+++ /server/trunk/web/root/templates/includes/header.tt	(revision 189)
@@ -29,4 +29,5 @@
         <li><a href="[% c.uri_for('/explorer') %]">Explorer</a></li>
         <li><a href="[% c.uri_for('/sources') %]">Source & Patches</a></li>
+        <li><a href="[% c.uri_for('/chat') %]">Chat</a></li>
         <li><a href="[% c.uri_for('/help') %]">Help</a></li>
         </ul>