Index: server/trunk/web/root/static/sophie.css
===================================================================
--- server/trunk/web/root/static/sophie.css	(revision 229)
+++ server/trunk/web/root/static/sophie.css	(revision 230)
@@ -1,3 +1,4 @@
 /* $Id$ */
+
 /* global look */
 a:link {
@@ -17,124 +18,13 @@
 }
 
-/* header look */
-div#sophie_header {
-  border: none;
-  background-color: #74D100;
-}
-
-#sophie_header a:visited {
-  color: #F7A800;
-}
-
-div#sophie_header img {
-  float: left;
-}
-
-span#sophie_login {
-  float: right;
-} 
-
-p#sophie_sitename {
-    font-size: 1.4em;
-    padding-left: 1em;
-}
-
-div#sophie_header_menu {
-  float: left;
-  padding: 0.5em;
-}
-
-#sophie_site_path {
-  font-size: 0.9em;
-  padding-left: 0.2em;
-  float: left;
-}
-
-div#sophie_header_search {
-  float: right;
-}
-
-/* foot look */
-div.sophie_footer img {
-  color: #FFFFFF;
-  vertical-align: middle;
-}
-
-div.sophie_footer p {
-  text-align: center;
-}
-
-/* home look */
-div#body_home {
-    float:left;
-    font-size: 1.2em;
-    padding: 0.5em;
-    width: 45%;
-    overflow: hidden;
-}
-
-/* search look */
-div#sophie_search_form {
-    padding-top: 1em;
-    padding-left: 0.2em;
-}
-
-.sophie_search_result_pager {
-    text-align: center;
-}
-
-.sophie_search_result_pager img {
-    color: #FFFFFF;
-    vertical-align: middle;
-}
-
-div.sophie_search_list {
-    border: none;
-    padding-left: 0.5em;
-    padding-top: 0.2em;
-    background: #f3f47a;
-    margin-top: 1em;
-    margin-left: 5%;
-    margin-right: 5%;
-}
-
-.sophie_search_list h2 {
-    margin-top: 0em;
-    margin-bottom: 0.5em;
-}
-
-.sophie_search_list p {
-    padding-left: 2em;
-    padding-right: 0em;
-    padding-top: 0em;
-    padding-bottom: 0em;
-    margin: 0em;
-    margin-bottom: 0.2em;
-}
-
-.sophie_search_list ul {
-    padding-left: 4em;
-    padding-right: 0em;
-    padding-top: 0.2em;
-    padding-bottom: 0em;
-    margin: 0em;
-    margin-bottom: 0.2em;
-}
-
-/* Tout ce qui reste */
-.flat_menu li {
-    font-size: 1.2em;
-    font-weight: bold;
-    margin-left: 0em;
-    display: inline;
-}
-
-.flat_menu {
+ul.sophie_tag {
     padding-left: 0em;
 }
 
-/* body_home : Id for home part of index.html */
-
-div#body_main {
+.sophie_tag li {
+    list-style-type: none;
+}
+
+div#sophie_body_main {
     float:left;
     padding-left: 1em;
@@ -143,5 +33,5 @@
 }
 
-div#body_additional {
+div#sophie_body_additional {
     float:left;
     border: solid #573B1D;
@@ -155,27 +45,91 @@
 }
 
-#sophie_rpms_menu {
-    margin-left: 1em;
-    padding-left: 0em;
-    padding-top: 0.5em;
-    padding-bottom: 0.5em;
-}
-
-#sophie_rpms_menu li {
+.filename {
+    font-family: monospace;
+}
+
+.filename td {
+    padding-left: 1em;
+    padding-right: 1em;
+    font-size: 1.2em;
+}
+
+pre.filedata {
+    padding: 2em;
+    margin: 2em;
+    background: #F5F5DC;
+    border: outset;
+}
+
+.flat_menu li {
+    font-size: 1.2em;
+    font-weight: bold;
     margin-left: 0em;
     display: inline;
 }
 
-#sophie_rpm_description p {
+.flat_menu {
     padding-left: 0em;
-    padding-right: 0em;
-    font-size: 0.9em;
-}
-
-div#sophie_chat {
-    float: left;
-    width: 35%;
-    padding-top: 1em;
-    padding-left: 0.2em;
+}
+
+/* header look */
+div#sophie_header {
+  border: none;
+  background-color: #74D100;
+}
+
+#sophie_header a:visited {
+  color: #F7A800;
+}
+
+div#sophie_header img {
+  float: left;
+}
+
+span#sophie_login {
+  float: right;
+} 
+
+p#sophie_sitename {
+    font-size: 1.4em;
+    padding-left: 1em;
+}
+
+div#sophie_header_menu {
+  float: left;
+  padding: 0.5em;
+}
+
+#sophie_site_path {
+  font-size: 0.9em;
+  padding-left: 0.2em;
+  float: left;
+}
+
+div#sophie_header_search {
+  float: right;
+}
+
+/* footer look */
+div.sophie_footer img {
+  color: #FFFFFF;
+  vertical-align: middle;
+}
+
+div.sophie_footer p {
+  text-align: center;
+}
+
+#w3c {
+    float: right;
+}
+
+/* home look */
+div#sophie_body_home {
+    float:left;
+    font-size: 1.2em;
+    padding: 0.5em;
+    width: 45%;
+    overflow: hidden;
 }
 
@@ -205,4 +159,58 @@
 }
 
+/* search look */
+div#sophie_search_form {
+    padding-top: 1em;
+    padding-left: 0.2em;
+}
+
+.sophie_search_result_pager {
+    text-align: center;
+}
+
+.sophie_search_result_pager img {
+    color: #FFFFFF;
+    vertical-align: middle;
+}
+
+div.sophie_search_list {
+    border: none;
+    padding-left: 0.5em;
+    padding-top: 0.2em;
+    background: #f3f47a;
+    margin-top: 1em;
+    margin-left: 5%;
+    margin-right: 5%;
+}
+
+.sophie_search_list h2 {
+    margin-top: 0em;
+    margin-bottom: 0.5em;
+}
+
+.sophie_search_list p {
+    padding-left: 2em;
+    padding-right: 0em;
+    padding-top: 0em;
+    padding-bottom: 0em;
+    margin: 0em;
+    margin-bottom: 0.2em;
+}
+
+.sophie_search_list ul {
+    padding-left: 4em;
+    padding-right: 0em;
+    padding-top: 0.2em;
+    padding-bottom: 0em;
+    margin: 0em;
+    margin-bottom: 0.2em;
+}
+
+/* distrib look */
+.sophie_pkgid {
+    font-family: monospace;
+}
+
+/* explorer look */
 #explorer_d {
     margin-top: 0.5em;
@@ -210,22 +218,5 @@
 }
 
-div#exp_dir {
-    margin-top: 0.5em;
-    margin-left: 0.2em;
-}
-
-div#exp_file {
-    padding-left: 0.2em;
-    padding-right: 0.2em;
-    padding-top: 0.2em;
-    padding-bottom: 0.2em;
-    margin-top: 0.5em;
-    margin-left: 0.2em;
-    float: left;
-    border: solid #573B1D;
-    width: 65%;
-}
-
-div#sophie_explorer_form {
+div#explorer_form {
     padding-left: 0.2em;
     padding-right: 0.2em;
@@ -240,4 +231,54 @@
 }
 
+div#exp_dir {
+    margin-top: 0.5em;
+    margin-left: 0.2em;
+}
+
+div#exp_file {
+    padding-left: 0.2em;
+    padding-right: 0.2em;
+    padding-top: 0.2em;
+    padding-bottom: 0.2em;
+    margin-top: 0.5em;
+    margin-left: 0.2em;
+    float: left;
+    border: solid #573B1D;
+    width: 65%;
+}
+
+/* source & patches look */
+div#sophie_sources {
+  padding-left: 0.5em;
+}
+
+/* rpms look */
+#sophie_rpms_menu {
+    margin-left: 1em;
+    padding-left: 0em;
+    padding-top: 0.5em;
+    padding-bottom: 0.5em;
+}
+
+#sophie_rpms_menu ul {
+  margin-left: 0.0em;
+}
+
+#sophie_rpms_menu li {
+    margin-left: 0em;
+    display: inline;
+}
+
+#sophie_rpms_menu h2 {
+  margin-left: 0.5em;
+}
+
+#sophie_rpm_description p {
+    padding-left: 0em;
+    padding-right: 0em;
+    font-size: 0.9em;
+}
+
+/* chat look */
 div#sophie_bot_reply {
     padding: 1em;
@@ -253,16 +294,23 @@
 }
 
+div#sophie_chat {
+    float: left;
+    width: 35%;
+    padding-top: 1em;
+    padding-left: 0.2em;
+}
+
+/* help look */
 .sophie_help h2 {
     font-size: 1.2em;
-/*    margin-top: 5em;*/
-    background-color: #EFF3F7;
+    background-color: #c0f57d;
 }
 
 .sophie_help code {
-    background-color: #FFFFC0;
+    background-color: #f3f47a;/*#FFFFC0;*/
 }
 
 .sophie_help pre {
-    background-color: #FFFFC0;
+    background-color: #f3f47a;/*##FFFFC0;*/
     padding: 1em;
     margin: 2em;
@@ -270,37 +318,10 @@
 }
 
-ul.sophie_tag {
-    padding-left: 0em;
-}
-
-.sophie_tag li {
-    list-style-type: none;
-}
-
-.pkgid {
-    font-family: monospace;
-}
-
-.filename {
-    font-family: monospace;
-}
-
-.filename td {
-    padding-left: 1em;
-    padding-right: 1em;
-    font-size: 1.2em;
-}
-
-pre.filedata {
-    padding: 2em;
-    margin: 2em;
-    background: #F5F5DC;
-    border: outset;
-}
-
+/* analysis look */
 .alert {
     color: red;
 }
 
+/* login look */
 div.sophie_auth {
     width: 40%;
@@ -317,5 +338,2 @@
 }
 
-#w3c {
-    float: right;
-}
Index: server/trunk/web/root/templates/html/distrib/media_list_rpms.html
===================================================================
--- server/trunk/web/root/templates/html/distrib/media_list_rpms.html	(revision 229)
+++ server/trunk/web/root/templates/html/distrib/media_list_rpms.html	(revision 230)
@@ -1,9 +1,8 @@
 <!-- $Id$ -->
-<div Id="body_main">
+<div Id="sophie_body_main">
 [% INCLUDE 'distrib/media_list_rpms.tt' %]
 </div>
 
-<div Id="body_additional">
-    <!-- <p> Slurp !</p> -->
+<div Id="sophie_body_additional">
     <p>Other medias:</p>
     [% INCLUDE 'distrib/distrib.tt'
Index: server/trunk/web/root/templates/html/distrib/media_rpm_bypkgid.tt
===================================================================
--- server/trunk/web/root/templates/html/distrib/media_rpm_bypkgid.tt	(revision 229)
+++ server/trunk/web/root/templates/html/distrib/media_rpm_bypkgid.tt	(revision 230)
@@ -5,5 +5,5 @@
 [% END %]
 <li>
-    <a href="[% c.uri_for('/', c.req.path, rpm.pkgid) %]"><span class="pkgid">[%
+    <a href="[% c.uri_for('/', c.req.path, rpm.pkgid) %]"><span class="sophie_pkgid">[%
 rpm.pkgid %]</span></a>
 ([% rpm.filename | html %])
Index: server/trunk/web/root/templates/html/distrib/rpm_bypkgid.tt
===================================================================
--- server/trunk/web/root/templates/html/distrib/rpm_bypkgid.tt	(revision 229)
+++ server/trunk/web/root/templates/html/distrib/rpm_bypkgid.tt	(revision 230)
@@ -5,5 +5,5 @@
 [% END %]
 <li>
-    <a href="[% c.uri_for('/', c.req.path, rpm.pkgid) %]"><span class="pkgid">[%
+    <a href="[% c.uri_for('/', c.req.path, rpm.pkgid) %]"><span class="sophie_pkgid">[%
 rpm.pkgid %]</span></a>
 ([% rpm.filename | html %])
Index: server/trunk/web/root/templates/html/explorer/index.html
===================================================================
--- server/trunk/web/root/templates/html/explorer/index.html	(revision 229)
+++ server/trunk/web/root/templates/html/explorer/index.html	(revision 230)
@@ -14,5 +14,5 @@
 ) %]
 
-<div id="sophie_explorer_form">
+<div id="explorer_form">
 <form action="#" method="POST">
     Filter to file starting by: 
@@ -34,5 +34,5 @@
 <hr>
 
-<div id="exp_dir" style="">
+<div id="exp_dir">
     Loading...
 </div>
Index: server/trunk/web/root/templates/html/index.tt
===================================================================
--- server/trunk/web/root/templates/html/index.tt	(revision 229)
+++ server/trunk/web/root/templates/html/index.tt	(revision 230)
@@ -3,5 +3,5 @@
 [% USE 'ObfuscateMail' %]
 
-<div id="body_home">
+<div id="sophie_body_home">
 <!-- Bonus for who will read this :)
 <p>Bonjour Ã  tous ! <br />
Index: server/trunk/web/root/templates/html/rpms/analyse.html
===================================================================
--- server/trunk/web/root/templates/html/rpms/analyse.html	(revision 229)
+++ server/trunk/web/root/templates/html/rpms/analyse.html	(revision 230)
@@ -19,5 +19,5 @@
 </form>
 
-<div id="body_main">
+<div id="sophie_body_main">
     [% INCLUDE 'rpms/analyse.tt' %]
 </div>
Index: server/trunk/web/root/templates/html/rpms/location.html
===================================================================
--- server/trunk/web/root/templates/html/rpms/location.html	(revision 229)
+++ server/trunk/web/root/templates/html/rpms/location.html	(revision 230)
@@ -4,9 +4,9 @@
 
 
-<div id="body_main">
+<div id="sophie_body_main">
     [% INCLUDE 'rpms/location.tt' %]
 </div>
 
-<div id="body_additional">
+<div id="sophie_body_additional">
     [% INCLUDE 'rpms/related.tt' %]
 </div>
Index: server/trunk/web/root/templates/html/rpms/menu.tt
===================================================================
--- server/trunk/web/root/templates/html/rpms/menu.tt	(revision 229)
+++ server/trunk/web/root/templates/html/rpms/menu.tt	(revision 230)
@@ -1,6 +1,7 @@
 <!-- $Id$ -->
-
+<div id="sophie_rpms_menu">
 <h2>[% rpms.info.filename | html %]</h2>
 
+<!-- <ul id="sophie_rpms_menu" class="flat_menu"> -->
 <ul id="sophie_rpms_menu" class="flat_menu">
 <li><a href="[% c.uri_for('/', rpmurl) %]">Info</a></li>
@@ -11,2 +12,3 @@
 <li><a href="[% c.uri_for('/', rpmurl, 'analyse') %]">Analyse</a></li>
 </ul>
+</div>
Index: server/trunk/web/root/templates/html/rpms/rpms.html
===================================================================
--- server/trunk/web/root/templates/html/rpms/rpms.html	(revision 229)
+++ server/trunk/web/root/templates/html/rpms/rpms.html	(revision 230)
@@ -3,10 +3,10 @@
 [% INCLUDE 'rpms/menu.tt' %]
 
-<div id="body_main">
+<div id="sophie_body_main">
 
     [% INCLUDE 'rpms/rpms.tt' %]
 </div>
 
-<div id="body_additional">
+<div id="sophie_body_additional">
     [% INCLUDE 'rpms/related.tt' %]
 </div>
Index: server/trunk/web/root/templates/html/sources/index.html
===================================================================
--- server/trunk/web/root/templates/html/sources/index.html	(revision 229)
+++ server/trunk/web/root/templates/html/sources/index.html	(revision 230)
@@ -1,3 +1,4 @@
 <!-- $Id$ -->
+<div id="sophie_sources">
 <p>Search source rpm having name starting by:</p>
 <form action="[% c.uri_for('/sources') %]" method="POST">
@@ -8,5 +9,5 @@
 [% FOREACH rpm = xmlrpc %]
 [% IF loop.first %]
-<ul>
+<ul class="sophie_tag">
 [% END %]
 <li><a href="[% c.uri_for('/sources', rpm) %]">[% rpm | html %]</a></li>
@@ -16,2 +17,3 @@
 
 [% END %]
+</div>