Index: server/trunk/web/lib/Sophie/Controller/Chat/Cmd.pm
===================================================================
--- server/trunk/web/lib/Sophie/Controller/Chat/Cmd.pm	(revision 291)
+++ server/trunk/web/lib/Sophie/Controller/Chat/Cmd.pm	(revision 292)
@@ -204,5 +204,5 @@
 }
 
-=head2 q REGEXP
+=head2 q [-d distrib] [-r release] [-a arch] [-s]  REGEXP
 
 Search rpm name matching C<REGEXP>.
@@ -222,4 +222,5 @@
             'd=s' => \$reqspec->{distribution},
             'v=s' => \$reqspec->{release},
+            'r=s' => \$reqspec->{release},
             'a=s' => \$reqspec->{arch},
             's'   => sub { $reqspec->{src} = 1 },
@@ -249,5 +250,5 @@
 }
 
-=head2 whatis WORD [WORD2 [...]]
+=head2 whatis [-d distrib] [-r release] [-a arch] [-s]  WORD [WORD2 [...]]
 
 Search rpm having description containing words given as arguments
@@ -264,4 +265,5 @@
             'd=s' => \$reqspec->{distribution},
             'v=s' => \$reqspec->{release},
+            'r=s' => \$reqspec->{release},
             'a=s' => \$reqspec->{arch},
             's'   => sub { $reqspec->{src} = 1 },
@@ -301,5 +303,5 @@
 }
 
-=head2 version [-s] NAME
+=head2 version [-d distrib] [-r release] [-a arch] [-s] NAME
 
 Show the version of package C<NAME>.
@@ -317,4 +319,5 @@
             'd=s' => \$reqspec->{distribution},
             'v=s' => \$reqspec->{release},
+            'r=s' => \$reqspec->{release},
             'a=s' => \$reqspec->{arch},
             's'   => sub { $reqspec->{src} = 1 },
@@ -354,5 +357,5 @@
 =head2 v
 
-C<v> is an alias for L<version> command.
+C<v> is an alias for C<version> command.
 
 =cut
@@ -363,5 +366,5 @@
 }
 
-=head2 summary [-s] NAME
+=head2 summary [-d distrib] [-r release] [-a arch] [-s]  NAME
 
 Show the summary of package C<NAME>.
@@ -386,5 +389,5 @@
 }
 
-=head2 packager [-s] NAME
+=head2 packager [-d distrib] [-r release] [-a arch] [-s]  NAME
 
 Show the packager of package C<NAME>.
@@ -409,5 +412,5 @@
 }
 
-=head2 arch [-s] NAME
+=head2 arch [-d distrib] [-r release] [-a arch] [-s]  NAME
 
 Show the architecture of package C<NAME>.
@@ -432,5 +435,5 @@
 }
 
-=head2 url [-s] NAME
+=head2 url [-d distrib] [-r release] [-a arch] [-s]  NAME
 
 Show the url of package C<NAME>.
@@ -455,5 +458,5 @@
 }
 
-=head2 group [-s] NAME
+=head2 group [-d distrib] [-r release] [-a arch] [-s] NAME
 
 Show the group of package C<NAME>.
@@ -478,5 +481,5 @@
 }
 
-=head2 license [-s] NAME
+=head2 license [-d distrib] [-r release] [-a arch] [-s] NAME
 
 Show the license of package C<NAME>.
@@ -501,5 +504,5 @@
 }
 
-=head2 buildtime [-s] NAME
+=head2 buildtime [-d distrib] [-r release] [-a arch] [-s] NAME
 
 Show the build time of package C<NAME>.
@@ -535,5 +538,5 @@
 }
 
-=head2 cookie [-s] NAME
+=head2 cookie [-d distrib] [-r release] [-a arch] [-s]  NAME
 
 Show the C<cookie> tag of package C<NAME>.
@@ -547,5 +550,5 @@
 }
 
-=head2 sourcerpm NAME
+=head2 sourcerpm [-d distrib] [-r release] [-a arch] [-s] NAME
 
 Show the C<sourcerpm> tag of package C<NAME>.
@@ -571,5 +574,5 @@
 }
 
-=head2 rpmversion NAME
+=head2 rpmversion [-d distrib] [-r release] [-a arch] [-s] NAME
 
 Show the C<rpmversion> tag of package C<NAME>.
@@ -596,5 +599,5 @@
 
 
-=head2 buildhost NAME
+=head2 buildhost [-d distrib] [-r release] [-a arch] [-s] NAME
 
 Show the C<buildhost> tag of package C<NAME>.
@@ -634,5 +637,5 @@
 
 
-=head2 distribution NAME
+=head2 distribution [-d distrib] [-r release] [-a arch] [-s] NAME
 
 Show the C<distribution> tag of package C<NAME>.
@@ -660,5 +663,5 @@
 
 
-=head2 vendor NAME
+=head2 vendor [-d distrib] [-r release] [-a arch] [-s] NAME
 
 Show the C<vendor> tag of package C<NAME>.
@@ -672,5 +675,9 @@
 }
 
-
+=head2 qf [-d distrib] [-r release] [-a arch] [-s] NAME FMT
+
+Perform an rpm -q --qf C<FMT> on package C<NAME>.
+
+=cut
 
 sub qf : XMLRPC {
@@ -683,4 +690,5 @@
             'd=s' => \$reqspec->{distribution},
             'v=s' => \$reqspec->{release},
+            'r=s' => \$reqspec->{release},
             'a=s' => \$reqspec->{arch},
             's'   => sub { $reqspec->{src} = 1 },
@@ -723,5 +731,5 @@
 }
 
-=head2 more NAME
+=head2 more [-d distrib] [-r release] [-a arch] [-s]  NAME
 
 Show url where details about package named C<NAME> can be found
@@ -738,4 +746,5 @@
             'd=s' => \$reqspec->{distribution},
             'v=s' => \$reqspec->{release},
+            'r=s' => \$reqspec->{release},
             'a=s' => \$reqspec->{arch},
             's'   => sub { $reqspec->{src} = 1 },
@@ -772,5 +781,5 @@
 }
 
-=head2 buildfrom NAME
+=head2 buildfrom [-d distrib] [-r release] [-a arch] NAME
 
 Return the list of package build from source package named C<NAME>
@@ -786,4 +795,5 @@
             'd=s' => \$reqspec->{distribution},
             'v=s' => \$reqspec->{release},
+            'r=s' => \$reqspec->{release},
             'a=s' => \$reqspec->{arch},
         }, @args ]) };
@@ -822,5 +832,5 @@
 }
 
-=head2 findfile FILE
+=head2 findfile [-d distrib] [-r release] [-a arch] [-s] FILE
 
 Return the rpm owning the file C<FILE>. 
@@ -838,5 +848,7 @@
             'd=s' => \$reqspec->{distribution},
             'v=s' => \$reqspec->{release},
+            'r=s' => \$reqspec->{release},
             'a=s' => \$reqspec->{arch},
+            's'   => \$reqspec->{src},
         }, @args ]) };
 
@@ -873,4 +885,11 @@
 }
 
+=head2 what [-d distrib] [-r release] [-a arch] [-s] p|r|c|o|e|s DEP [SENSE [EVR]]
+
+Search rpm matching having matching dependencies (provides, requires, conflicts,
+obsoletes, enhanced or suggests)
+
+=cut
+
 sub what : XMLRPC {
     my ($self, $c, $reqspec, @args) = @_;
@@ -880,4 +899,5 @@
             'd=s' => \$reqspec->{distribution},
             'v=s' => \$reqspec->{release},
+            'r=s' => \$reqspec->{release},
             'a=s' => \$reqspec->{arch},
             's'   => \$reqspec->{src},
@@ -911,5 +931,5 @@
 }
 
-=head2 maint RPMNAME
+=head2 maint [-d distrib] [-r release] [-a arch] [-s] RPMNAME
 
 Show the maintainers for the rpm named C<RPMNAME>.
@@ -925,5 +945,7 @@
             'd=s' => \$reqspec->{distribution},
             'v=s' => \$reqspec->{release},
+            'r=s' => \$reqspec->{release},
             'a=s' => \$reqspec->{arch},
+            's'   => \$reqspec->{src},
         }, @args ]) };
     if (!$c->forward('/distrib/exists', [ $reqspec ])) {